/*
 * This file is part of SkunkDB
 * Copyright (c) 2002 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <mpool.h>
#include <fbuf.h>
#include <avl.h>

int main (int argc, char **argv) 
{
	void *db;

	if ( !(db=avl_open(STDIN_FILENO)) ) {
		perror("avl_open()");
		return 1;
	}

	if ( argc!=3 ) {
		fprintf(stderr, "Usage: %s [start] [end] < dbfile\n", argv[0]);
		return 1;
	}

	avl_select(db, atoi(argv[1]), atoi(argv[2]));

	avl_close(db);
	return 0;
}
