/*
* This file is part of SkunkDB
* Copyright (c) 2001 Gianni Tedesco
*
* This is probably rather insecure. Need to audit the code here really.
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <string.h>

#include <mpool.h>
#include <skunk.h>

#define min_buf 4096
char *mbuf=NULL;
size_t mlen=0;

/* this might be a tad confusing. This function esentially prints
* "key:value\n" in to a string. Just need to make sure the buffer
* is big enough each time if not we realloc a larger one.
*/
char *get_value(char *k, char *v, skunk_ofs_t klen, skunk_ofs_t vlen)
{
	size_t sz=klen+vlen+3;

	if ( ! (mbuf && mlen>=sz) ) {
		if ( sz<min_buf ) sz=min_buf;
		if ( mbuf ) {
			char *n;
			if ( !(n=realloc(mbuf, sz)) ) return NULL;
			mbuf=n;
		}else if ( !(mbuf=malloc(sz)) ) {
			return NULL;
		}
		mlen=sz;
	}

	memcpy(mbuf, k, klen);
	mbuf[klen]=':';
	memcpy(mbuf+klen+1, v, vlen);
	mbuf[klen+vlen+1]='\n';
	mbuf[klen+vlen+2]='\0';

	return mbuf;
}

int main ( int argc, char **argv ) 
{
	int i;
	char *map, *buf;
	struct stat st;
	struct skunk_table *p;
	skunk_ofs_t data=0,count=0;
	skunk_ofs_t min_fill=0, max_fill=0;
	char *str;
	
	if ( (buf=malloc(8192)) ) {
		setvbuf(stdout, buf, _IOFBF, 8192);
	}
	
	if ( (fstat(STDIN_FILENO, &st)) < 0 ) {
		perror("fstat");
		return 1;
	}

	if ( st.st_size < sizeof(struct skunk_table)*SKUNK_HASHSZ ) {
		fprintf(stderr, "File is too small to be a skunk DB.\n");
		return 1;
	}
	
	if ( !(map=mmap(NULL, st.st_size, PROT_READ,
		MAP_SHARED, STDIN_FILENO, 0)) )
	{
		perror("mmap");
		return 1;
	}

	/* count bucket slots */
	for (i=0; i<SKUNK_HASHSZ; i++) {
		p=(struct skunk_table *)map +i;

		if ( i==0 ) min_fill=p->len;

		count+=p->len;
		if ( p->len > max_fill ) max_fill=p->len;
		if ( p->len < min_fill ) min_fill=p->len;
	}

#if 0
	printf("STATISTICS: optimal=%u min=%u max=%u\n\n",
		count/SKUNK_HASHSZ, min_fill, max_fill);
#endif

	/* loop through all hash table entries */
	data=SKUNK_HASHSZ*sizeof(struct skunk_table);
	for(i=0; i<count; i++) {
		struct rec r;
		struct skunk_bucket *b;

		b=((struct skunk_bucket *)map) + data;
		if ( !b->ofs ) goto game_over;
		
		r.key_len=b->klen;
		r.val_len=b->vlen;


		r.key=(char *)(((skunk_ofs_t )map)+b->ofs);
		r.val=(char *)(((skunk_ofs_t )map)+b->ofs+r.key_len);

		if ( b->ofs+r.key_len > st.st_size ) {
			fprintf(stderr, "bogus data for slot 0x%x\n", i);
			exit(1);
		}

		if ( (str=get_value(r.key, r.val, r.key_len, r.val_len)) ) {
			printf("%s", str);
		}else{
			fprintf(stderr, "unable to retrieve data at slot 0x%x\n", i);
		}
game_over:
		data+=sizeof(struct skunk_bucket);

		/* quick and dirty check */
		if ( data > st.st_size ) break;
	}
	
	munmap(map, st.st_size);
	exit(0);
}
